
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

import had.Kosticka;
import had.Back;
import had.RunThread;

/*
 * Created on 2.11.2005
 * Program Had - simulator hada
 */

/**
 * @author fsramej1 Spustitelna trida aplikace Had
 */
public class HadApp extends JFrame {

	private JButton btStart;

	private JButton btKonec;

	private JButton btAbout;

	private JPanel f1;

	private Back f2;

	private JPanel f3;

	private Kosticka kostka;

	private RunThread thread;

	public Container okno;

	static String ver = "1.0a";

	/**
	 * Konstruktor aplikanho okna
	 * 
	 * @param title
	 */
	public HadApp(String title) {

		/*
		 * Zakladni okno
		 *  
		 */
		setTitle(title);
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		setSize(274, 300);
		setResizable(false);
		setLocation(350, 150);

		/*
		 * Naplneni okna objekty
		 *  
		 */
		okno = getContentPane();
		thread = new RunThread();
		ActionListener buttonlistener = new Listener();
		FlowLayout left = new FlowLayout(FlowLayout.LEFT);

		// Panel TOP
		f1 = new JPanel(left);
		f1.setBorder(BorderFactory.createEtchedBorder());
		okno.add(f1, BorderLayout.NORTH);

		// Panel MIDDLE - instance tridy Back
		f2 = thread.getBack();
		f2.setBorder(BorderFactory.createEtchedBorder());
		okno.add(f2, BorderLayout.CENTER);

		// Panel BOTTOM
		f3 = new JPanel();
		f3.setBorder(BorderFactory.createEtchedBorder());
		okno.add(f3, BorderLayout.SOUTH);

		// Vkladani objektu na hlavni okno
		btStart = new JButton("Start / Pauza");
		btKonec = new JButton("Konec");
		btAbout = new JButton("About");
		f1.add(btStart);
		f1.add(btKonec);
		f1.add(btAbout);
		btStart.addActionListener(buttonlistener);
		btKonec.addActionListener(buttonlistener);
		btAbout.addActionListener(buttonlistener);
		f3.add(new JLabel("(C) Ji Rame 2005"));

		// Klavesovy listener pro f2 (Panel MIDDLE)
		f2.addKeyListener(new KeyAdapter() {
			public void keyPressed(KeyEvent e) {
				switch (e.getKeyCode()) {
				case 37: // '%' doleva
					f2.getHad().setSmer(1);
					break;

				case 39: // '\'' doprava
					f2.getHad().setSmer(2);
					break;

				case 38: // '&' nahoru
					f2.getHad().setSmer(3);
					break;

				case 40: // '(' dolu
					f2.getHad().setSmer(4);
					break;
				}
			}

		});
	} // konec konstruktoru

	/**
	 * Spousteci metoda main
	 * 
	 * @param args
	 */
	public static void main(String[] args) {
		new HadApp("Had v " + ver).setVisible(true);
	}

	/**
	 * 
	 * @author Jirka Vnitrni trida s ActionListenerem pro tlacitka v okne
	 */
	class Listener implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			if (e.getSource() == btAbout) {
				// Button About
				f2.grabFocus();
				JOptionPane.showMessageDialog(okno, "Program Had v " + ver
						+ "\n(C) Ji Rame 2005", "O programu...",
						JOptionPane.INFORMATION_MESSAGE);

			} else if (e.getSource() == btStart) {
				// Button Start
				if (f2.getHad().getKonec()) {
					f2.getHad().vymaz();
					f2.repaint();
					f2.newGame();
					f2.grabFocus();
					thread.getBack().getHad().setAktivni(true);
					if (!(thread.isAlive())) {
						thread.start();
					} else {
						thread.resume();
					}
				} else {
					if (thread.getBack().getHad().isAktivni()) {
						thread.getBack().getHad().setAktivni(false);
						thread.suspend();
					} else {
						thread.getBack().getHad().setAktivni(true);
						f2.grabFocus();
						thread.resume();
					}
				}

			} else if (e.getSource() == btKonec) {
				// Button Konec
				System.exit(0);
			}
		}

	} // Konec vnitrni tridy

}