/*
 * Created on 25.11.2005
 * Trida Back
 */
package had;

import javax.swing.JPanel;
import had.Had;
import java.util.Random;

/**
 * @author fsramej1 Instance tridy Back vytvari JPanel na ktery vykreslujeme
 *         hada
 */
public class Back extends JPanel {

	private Kosticka kostka;

	private Jidlo jidlo;

	private Random random;

	public Had had;

	/**
	 * Vymaze celou plochu pro vykresleni hada. Pouziva k tomu vykresleni
	 * prazdneho obdelnika coz zamezi blikani pri posuvu (prekreslovani) hada
	 *  
	 */
	public void smazBack() {
		getGraphics().clearRect(2, 2, getWidth() - 4, getHeight() - 4);
	}

	/**
	 * Kostruktor instance tridy Back - vytvori instance hada a generatoru
	 * nahodnych cisel
	 *  
	 */
	public Back() {
		had = new Had();
		random = new Random(System.currentTimeMillis());
	}

	/**
	 * Vytvori jidlo s nahodnou souradnici umisteni
	 *  
	 */
	public void generujJidlo() {
		int x = 1;
		int y = 1;
		boolean ok = false;
		while (!ok) {
			x = random.nextInt(19) + 1;
			y = random.nextInt(14) + 1;
			ok = true;
			for (int i = 0; i < had.getPocet(); i++) {
				kostka = (Kosticka) had.get(i);
				if ((kostka.getX() == x) && (kostka.getY() == y)) {
					ok = false;
				}
			}
		}
		getHad().ham = new Jidlo(x, y);
	}

	/**
	 * Vrati instanci hada
	 * 
	 * @return Instance hada
	 */
	public Had getHad() {
		return had;
	}

	/**
	 * Prekresli obrazovku, tzn. hada i jidlo. Je volano vzdy po uskutecnenem
	 * pohybu
	 *  
	 */
	private void prekresli() {
		boolean snedeno = false;
		// jidlo
		smazBack();
		jidlo = (Jidlo) had.getJidlo();
		jidlo.kresli(getGraphics());
		// had
		for (int i = 0; i < had.getPocet(); i++) {
			kostka = (Kosticka) had.get(i);
			kostka.kresli(getGraphics());

			if ((jidlo.getX() == kostka.getX())
					&& (jidlo.getY() == kostka.getY())) {
				snedeno = true;
			}
		}
		if (snedeno) {
			had.pridej(new Kosticka(jidlo.getX(), jidlo.getY()));
			generujJidlo();
			jidlo = (Jidlo) had.getJidlo();
			jidlo.kresli(getGraphics());
		}
	}

	/**
	 * Vola se pri spusteni hry, pripravi vychoziho hada a jidlo
	 *  
	 */
	public void newGame() {
		generujJidlo();
		had.vymaz();
		had.pridej(new Kosticka(3, 1));
		had.pridej(new Kosticka(2, 1));
		had.pridej(new Kosticka(1, 1));
		prekresli();
		had.smer = 2;
		had.psmer = 2;
		had.setKonec(false);
	}

	/**
	 * Zavola metodu pro pohyb hada doprava. Pote obslouzi prekresleni
	 * obrazovky.
	 *  
	 */
	public void doprava() {
		had.moveDoprava();
		prekresli();
	}

	/**
	 * Zavola metodu pro pohyb hada doleva. Pote obslouzi prekresleni obrazovky.
	 *  
	 */
	public void doleva() {
		had.moveDoleva();
		prekresli();
	}

	/**
	 * Zavola metodu pro pohyb hada nahoru. Pote obslouzi prekresleni obrazovky.
	 *  
	 */
	public void nahoru() {
		had.moveNahoru();
		prekresli();
	}

	/**
	 * Zavola metodu pro pohyb hada dolu. Pote obslouzi prekresleni obrazovky.
	 *  
	 */
	public void dolu() {
		had.moveDolu();
		prekresli();
	}

}